import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;

import com.java4less.vision.RImage;
import com.java4less.vision.qrcode.QRCodeData;
import com.java4less.vision.qrcode.QRCodeReader;




public class QRCodeSample {
	
	
	private String[] testSet={ "qrcode10bw90.png", "qrcode7bw2.png","foto0072.png" ,"qrcode.png","qrcode2.png","qrcode3.png","qrcode6.png"};

	private String dir="images\\";
	
	public static void main(String[] args)  {
			
		QRCodeSample sample=new QRCodeSample();
		try {
			

			sample.runTests();
		} catch (Exception e) {

			e.printStackTrace();
		}
		System.exit(0);
		
	}
	
	/**
	 * read all test files
	 *
	 */
	public void runTests() {		
		for (int i=0;i<testSet.length;i++) {
			try {
				
				System.out.println("");
				System.out.println("------------------------------");
				System.out.println("Scanning File: "+testSet[i]);
				System.out.println("");
				scanImage(testSet[i]);
				System.out.println("------------------------------");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}		
	}
	
	/**
	 * scan file
	 * @param file image file

	 * @throws Exception
	 */
	public void scanImage(String file) throws Exception {
		
		Image im=loadImage(dir+file);
		
		QRCodeReader reader=new QRCodeReader();

		
		RImage rim=new RImage((BufferedImage) im);

        
        QRCodeData[] barcodes=reader.read(rim);
		rim=null;
		im=null;
		
		if (barcodes.length==0) System.out.println("*** NO BARCODE FOUND ***");
		
		for (int i=0;i<barcodes.length;i++) {
			
			if (!barcodes[i].isDecodingSuccessfull()) System.out.println("\nBarcode found but It CONTAINS ERRORS which could not be corrected\n"+barcodes[i].toString());
			else System.out.println("\nBarcode  found "+barcodes[i].toString());
			
			
			
		}
						
	}
	
	/**
	 * load image from file
	 * @param f
	 * @return
	 * @throws Exception
	 */
	public Image loadImage(String f) throws Exception {
			Image im2=null;
			java.awt.MediaTracker mt2=null;

			java.io.FileInputStream in=null;
			byte[] b=null;
			int size=0;


			in=new java.io.FileInputStream( f);
			if (in!=null) {
				size=in.available();
				b=new byte[size];
				in.read(b);
				im2=java.awt.Toolkit.getDefaultToolkit().createImage(b);
				in.close();
			}

			mt2 = new java.awt.MediaTracker(new Canvas());		
			if (im2!=null) {
				if (mt2!=null) {mt2.addImage(im2,0); mt2.waitForID(0);}
				int WidthIm = im2.getWidth(null);
			}


		BufferedImage input=new BufferedImage(im2.getWidth(null),im2.getHeight(null),BufferedImage.TYPE_INT_ARGB);
		
		Graphics g=input.createGraphics();
		g.setColor(Color.white);
		g.fillRect(0,0,im2.getWidth(null),im2.getHeight(null));
		g.drawImage(im2,0,0,null);
		g.dispose();
		g=null;
		
		return input;


		}	

}
